package board;

import java.util.*;
import java.awt.*;
import java.io.*;

public class Record
{
	private Vector strokes;
	public Record(){
		strokes = new Vector();
	}
	
	public void addStroke(Stroke stroke){
		strokes.addElement(stroke);
	}
	public Vector getStrokes(){
		return strokes;
	}
	public void addStrokes(Vector _strokes){
		strokes = Util.appendVector(strokes, _strokes);
	}
	public void removeStrokes(Vector _strokes){
		for(int i=0; i<_strokes.size(); i++){
			Stroke stroke = ((Stroke)_strokes.elementAt(i));
			strokes.removeElement(stroke);
		}
	}
	
	public void clear(){
		strokes = new Vector();
	}
	
	public void paint(Graphics g){
		g.setColor(Color.black);
		for(int i=0; i<strokes.size(); i++){
			((Stroke)strokes.elementAt(i)).paint(g);
		}
	}
	
	
	
	
	
	
	
	
	
	
	public void save(String filename){

		try{
		
		BufferedWriter out   = new BufferedWriter(new FileWriter(filename)); 
		
		for(int i=0; i<strokes.size(); i++){
			((Stroke)strokes.elementAt(i)).save(out);
		}

		out.flush();
		out.close();

		}catch(IOException e) { System.out.print("IO Error "+e);}
		
	}

	
	public void load(String filename){
		strokes = new Vector();

		try{
		BufferedReader in = new BufferedReader(new FileReader(filename));
		
		while (true){
			String line = in.readLine();	//"problem"
			if (line == null)
				break;

			Stroke stroke = new Stroke();
			stroke.load(in);
			strokes.addElement(stroke);
		}
		in.close();
		
		}
		catch(IOException e) { System.out.print("IO Error "+e);}

		
		
		
		
	}	
	
}
