package board;


import java.awt.*;
import java.util.*;

public class StrokeAnalyzer
{
		
	
	public static Stroke resample_by_length(Stroke stroke, int n){
		Vector points = new Vector();
		for(int i=0; i<stroke.points.size(); i++){
			points.addElement(new Vertex2D((Point)stroke.points.elementAt(i)));
		}
		
		points = resample(points, n);
		
		Stroke resampled = new Stroke();
		resampled.points = new Vector();
		for(int i=0; i<points.size(); i++){
			resampled.points.addElement(((Vertex2D)points.elementAt(i)).point());
		}
		return resampled;
	}
	public static Stroke resample_by_number(Stroke stroke, int n){
		Vector points = new Vector();
		for(int i=0; i<stroke.points.size(); i++){
			points.addElement(new Vertex2D((Point)stroke.points.elementAt(i)));
		}
		
		points = resample_by_number(points, n);
		
		Stroke resampled = new Stroke();
		resampled.points = new Vector();
		for(int i=0; i<points.size(); i++){
			resampled.points.addElement(((Vertex2D)points.elementAt(i)).point());
		}
		return resampled;
	}
	public static double distance(Stroke stroke, Point p){	
		double min = -1;
        for(int i=0; i<stroke.points.size(); i++){
            Point v = (Point) stroke.points.elementAt(i);
			double d = Vertex2D.distance(v, p);
			if (min == -1 || min > d)
				min = d;
		}
		return min;
	}	

	
	
	
	
	
	
	
	
	
	
	
	
	
	public static void paint_stroke(Vector points, Graphics g){
        for(int i=0; i<points.size()-1; i++){
            Vertex2D p = (Vertex2D) points.elementAt(i);
            Vertex2D q = (Vertex2D) points.elementAt(i+1);
            g.drawLine((int)p.x, (int)p.y, (int)q.x, (int)q.y);
        }		
	}	
	public static double distance(Vector stroke, Vertex2D p){	
		double min = -1;
        for(int i=0; i<stroke.size(); i++){
            Vertex2D v = (Vertex2D) stroke.elementAt(i);
			double d = Vertex2D.distance(v, p);
			if (min == -1 || min > d)
				min = d;
		}
		return min;
	}	
	
	public static double calculate_area(Vector stroke){	
		Vertex2D p = (Vertex2D) stroke.elementAt(stroke.size()-1);
		double area = 0;
		for(int i=0; i<stroke.size(); i++){
			Vertex2D q = (Vertex2D) stroke.elementAt(i);
			area += Vector2D.cross_product(p, q);
			p = q;
		}
		return area;
	}
		
		
	
	
	
	
	
	
	
	static public Vector resample(Vector stroke, int UNIT_LENGTH){
		if (stroke.size() <=2)
			return stroke;
		
		double length = get_length(stroke);	
		int n = (int) (length / UNIT_LENGTH + 0.5);
		
		return resample_by_number(stroke, n);
	}
	static public Vector resample_by_number(Vector stroke, int n){
		double length = get_length(stroke);		
		double unit = length/n;

		Vertex2D v0 = (Vertex2D) stroke.elementAt(0);
		Vertex2D v1 = (Vertex2D) stroke.elementAt(stroke.size()-1);
		
		
		Vector resampled = new Vector();
		resampled.addElement(v0);
		
		double total = 0;
		double prev_total=0;
		Vertex2D prev = v0;
		Vertex2D next;
		double next_spot = unit;
		int index = 1;
		int count = 0;
		while(true){
			next = (Vertex2D) stroke.elementAt(index);
			
			total += Vertex2D.distance(prev, next);
			while (total >= next_spot)	{
				Vertex2D new_vertex = Vertex2D.interporate(prev, next, (next_spot-prev_total)/(total-prev_total));
				resampled.addElement(new_vertex);
				next_spot += unit;
				count++;
				if (count == n-1)
					break;
			}
			if (count == n-1)
				break;
			prev = next;
			prev_total = total;
			index++;
			
		}
		
		resampled.addElement(v1);
		return resampled;
	}
	
	static public double get_length(Vector stroke){
		double length = 0;
		for(int i=0; i<stroke.size()-1; i++){
            Vertex2D p = (Vertex2D) stroke.elementAt(i);
            Vertex2D q = (Vertex2D) stroke.elementAt(i+1);
			length += Vertex2D.distance(p,q);
		}
		return length;
	}

}
